﻿
**MICROSOFT SOFTWARE LICENSE TERMS**


**MICROSOFT WINDOWS SYSTEM KIT (WSK) FOR WINDOWS FACTORY OS**

These license terms are an agreement between you and Microsoft Corporation (or one of its affiliates). They apply to the software named above and any Microsoft services or software updates (except to the extent such services or updates are accompanied by new or additional terms, in which case those different terms apply prospectively and do not alter your or Microsoft’s rights relating to pre-updated software or services). IF YOU COMPLY WITH THESE LICENSE TERMS, YOU HAVE THE RIGHTS BELOW. BY USING THE SOFTWARE, YOU ACCEPT THESE TERMS. 

1. **INSTALLATION AND USE RIGHTS.** 
   1. **Installation and Use.**
- You may install and use any number of copies of the software on your premises to design, develop and test your programs for use with Microsoft operating systems.
- You may install, use and/or deploy via a network management system or as part of a desktop image, any number of copies of the software on computer devices within your internal corporate network to design, develop and test your programs that run on a Microsoft operating system. Each copy must be complete, including all copyright and trademark notices. You must require end users to agree to terms that protect the software as much as these license terms. 
  1. **Third Party Software.**  The software may include third party code that Microsoft, not the third party, licenses to you under this agreement. Notices, if any, for the third party code are included for your information only. Notices, if any, for this third party code are included with the software and may be found in the ThirdPartyNotices.txt or credits.rtf file associated with the software.
1. **DATA.**
   1. **Data Collection.** The software may collect information about you and your use of the software and send that to Microsoft. Microsoft may use this information to provide services and improve Microsoft’s products and services. Your opt-out rights, if any, are described in the product documentation. Some features in the software may enable collection of data from users of your applications that access or use the software. If you use these features to enable data collection in your applications, you must comply with applicable law, including getting any required user consent, and maintain a prominent privacy policy that accurately informs users about how you use, collect, and share their data. You can learn more about Microsoft’s data collection and use in the product documentation and the Microsoft Privacy Statement at <https://go.microsoft.com/fwlink/?LinkId=512132>. You agree to comply with all applicable provisions of the Microsoft Privacy Statement.
   1. **Processing of Personal Data.** To the extent Microsoft is a processor or subprocessor of personal data in connection with the software, Microsoft makes the commitments in the European Union General Data Protection Regulation Terms of the Online Services Terms to all customers effective May 25, 2018, at <https://docs.microsoft.com/en-us/legal/gdpr>.
1. **ADDITIONAL LICENSING REQUIREMENTS AND/OR USE RIGHTS.**  
   1. **Distributable Code.** The software contains code that you are permitted to distribute in programs you develop if you comply with the terms below.
      1. **Distribution Rights.** The code listed below are distributable if included with the software.

- Binaries. Subject to the license terms for the software, the following .efi files may be distributed unmodified as part of your UEFI firmware:

1. Program Files\Windows Kits\10\EFIFiles\x86\ufpdevicefw.efi
1. Program Files\Windows Kits\10\EFIFiles\x64\ufpdevicefw.efi
1. Program Files\Windows Kits\10\EFIFiles\arm\ufpdevicefw.efi
1. Program Files\Windows Kits\10\EFIFiles\arm64\ufpdevicefw.efi


- Certificates.

- Program Files\Windows Kits\10\Tools\certificates\Microsoft\_Development\_PCA\_2014.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_App\_Test\_Cert\_2013.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_App\_Test\_Cert\_2017.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_HAL\_Extension\_Test\_Cert\_2013.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_HAL\_Extension\_Test\_Cert\_2017.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_Intermediate\_Cert.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_Intermediate\_Cert\_2017.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_Intermediate\_FFU\_Cert.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_Intermediate\_FFU\_Cert\_2017.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_PPL\_Test\_Cert\_2013.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_PPL\_Test\_Cert\_2017.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_PP\_Test\_Cert\_2013.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_PP\_Test\_Cert\_2017.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_Root\_CA.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_Root\_CA2.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_Root\_CA\_2017.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_Test\_Cert\_2013.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_Test\_Cert\_2017.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_Test\_PK\_Cert\_2013.cer
- Program Files\Windows Kits\10\Tools\certificates\OEM\_Test\_PK\_Cert\_2017.cer

- Third Party Distribution. You may permit distributors of your programs to copy and distribute any of the distributable code as part of those programs.
  1. **Distribution Requirements.** For any code you distribute, you must:
     1. add significant primary functionality to it in your applications;
     1. require distributors and external end users to agree to terms that protect it and Microsoft at least as much as this agreement; and
     1. indemnify, defend, and hold harmless Microsoft from any claims, including attorneys’ fees, related to the distribution or use of your applications, except to the extent that any claim is based solely on the unmodified distributable code.
  1. **Distribution Restrictions.** You may not:
     1. Distribute the code and text files for use in live operating environment;
     1. use Microsoft’s trademarks or trade dress in your application in any way that suggests your application comes from or is endorsed by Microsoft; or
     1. modify or distribute the source code of any distributable code so that any part of it becomes subject to any license that requires that the distributable code, any other part of the software, or any of Microsoft’s other intellectual property be disclosed or distributed in source code form, or that others have the right to modify it.
1. **.NET FRAMEWORK SOFTWARE.** The software contains Microsoft .NET Framework software. This software is part of Windows. The license terms for Windows apply to your use of the .NET Framework software.
1. **SCOPE OF LICENSE.** The software is licensed, not sold. Microsoft reserves all other rights. Unless applicable law gives you more rights despite this limitation, you will not (and have no right to):
- Except for the Microsoft .NET Framework, you must obtain Microsoft's prior written approval to disclose to a third party the results of any benchmark test of the software. You may conduct internal benchmark testing of .NET components and disclose the results of any benchmark test of those components under the conditions set forth at go.microsoft.com/fwlink/?LinkID=66406.
- work around any technical limitations in the software;
- reverse engineer, decompile or disassemble the software;
- publish the software for others to copy;
- remove, minimize, block, or modify any notices of Microsoft or its suppliers in the software;
- use the software for commercial software hosting services;
- use the software in any way that is against the law or to create or propagate malware; or
- share, publish, distribute, or lend the software (except for any distributable code, subject to the terms above), provide the software as a stand-alone hosted solution for others to use, or transfer the software or this agreement to any third party.

1. **DOCUMENTATION.** Any person that has valid access to your computer or internal network may copy and use the documentation for your internal, reference purposes.
1. **EXPORT RESTRICTIONS.** You must comply with all domestic and international export laws and regulations that apply to the software, which include restrictions on destinations, end users, and end use. For further information on export restrictions, visit http://aka.ms/exporting.
1. **SUPPORT SERVICES.** Microsoft is not obligated under this agreement to provide any support services for the software. Any support provided is “as is”, “with all faults”, and without warranty of any kind.
1. **ENTIRE AGREEMENT.** This agreement, and any other terms Microsoft may provide for supplements, updates, or third-party applications, is the entire agreement for the software.
1. **APPLICABLE LAW AND PLACE TO RESOLVE DISPUTES.** If you acquired the software in the United States or Canada, the laws of the state or province where you live (or, if a business, where your principal place of business is located) govern the interpretation of this agreement, claims for its breach, and all other claims (including consumer protection, unfair competition, and tort claims), regardless of conflict of laws principles. If you acquired the software in any other country, its laws apply. If U.S. federal jurisdiction exists, you and Microsoft consent to exclusive jurisdiction and venue in the federal court in King County, Washington for all disputes heard in court. If not, you and Microsoft consent to exclusive jurisdiction and venue in the Superior Court of King County, Washington for all disputes heard in court.
1. **CONSUMER RIGHTS; REGIONAL VARIATIONS.** This agreement describes certain legal rights. You may have other rights, including consumer rights, under the laws of your state, province, or country. Separate and apart from your relationship with Microsoft, you may also have rights with respect to the party from which you acquired the software. This agreement does not change those other rights if the laws of your state, province, or country do not permit it to do so. For example, if you acquired the software in one of the below regions, or mandatory country law applies, then the following provisions apply to you:
1) **Australia.** You have statutory guarantees under the Australian Consumer Law and nothing in this agreement is intended to affect those rights.
1) **Canada.** If you acquired this software in Canada, you may stop receiving updates by turning off the automatic update feature, disconnecting your device from the Internet (if and when you re-connect to the Internet, however, the software will resume checking for and installing updates), or uninstalling the software. The product documentation, if any, may also specify how to turn off updates for your specific device or software.
1) **Germany and Austria.**
i.	**Warranty.** The properly licensed software will perform substantially as described in any Microsoft materials that accompany the software. However, Microsoft gives no contractual guarantee in relation to the licensed software.

ii.	**Limitation of Liability**. In case of intentional conduct, gross negligence, claims based on the Product Liability Act, as well as, in case of death or personal or physical injury, Microsoft is liable according to the statutory law.

Subject to the foregoing clause ii., Microsoft will only be liable for slight negligence if Microsoft is in breach of such material contractual obligations, the fulfillment of which facilitate the due performance of this agreement, the breach of which would endanger the purpose of this agreement and the compliance with which a party may constantly trust in (so-called "cardinal obligations"). In other cases of slight negligence, Microsoft will not be liable for slight negligence.

1. **DISCLAIMER OF WARRANTY. THE SOFTWARE IS LICENSED “AS IS.” YOU BEAR THE RISK OF USING IT. MICROSOFT GIVES NO EXPRESS WARRANTIES, GUARANTEES, OR CONDITIONS. TO THE EXTENT PERMITTED UNDER APPLICABLE LAWS, MICROSOFT EXCLUDES ALL IMPLIED WARRANTIES, INCLUDING MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT.**
1. **LIMITATION ON AND EXCLUSION OF DAMAGES. IF YOU HAVE ANY BASIS FOR RECOVERING DAMAGES DESPITE THE PRECEDING DISCLAIMER OF WARRANTY, YOU CAN RECOVER FROM MICROSOFT AND ITS SUPPLIERS ONLY DIRECT DAMAGES UP TO U.S. $5.00. YOU CANNOT RECOVER ANY OTHER DAMAGES, INCLUDING CONSEQUENTIAL, LOST PROFITS, SPECIAL, INDIRECT OR INCIDENTAL DAMAGES.**

**This limitation applies to (a) anything related to the software, services, content (including code) on third party Internet sites, or third party applications; and (b) claims for breach of contract, warranty, guarantee, or condition; strict liability, negligence, or other tort; or any other claim; in each case to the extent permitted by applicable law.**

**It also applies even if Microsoft knew or should have known about the possibility of the damages. The above limitation or exclusion may not apply to you because your state, province, or country may not allow the exclusion or limitation of incidental, consequential, or other damages.**

**Please note: As this software is distributed in Quebec, Canada, some of the clauses in this agreement are provided below in French.**

**Remarque : Ce logiciel étant distribué au Québec, Canada, certaines des clauses dans ce contrat sont fournies ci-dessous en français.**

**EXONÉRATION DE GARANTIE.** Le logiciel visé par une licence est offert « tel quel ». Toute utilisation de ce logiciel est à votre seule risque et péril. Microsoft n’accorde aucune autre garantie expresse. Vous pouvez bénéficier de droits additionnels en vertu du droit local sur la protection des consommateurs, que ce contrat ne peut modifier. La ou elles sont permises par le droit locale, les garanties implicites de qualité marchande, d’adéquation à un usage particulier et d’absence de contrefaçon sont exclues.

**LIMITATION DES DOMMAGES-INTÉRÊTS ET EXCLUSION DE RESPONSABILITÉ POUR LES DOMMAGES.** Vous pouvez obtenir de Microsoft et de ses fournisseurs une indemnisation en cas de dommages directs uniquement à hauteur de 5,00 $ US. Vous ne pouvez prétendre à aucune indemnisation pour les autres dommages, y compris les dommages spéciaux, indirects ou accessoires et pertes de bénéfices.

Cette limitation concerne:

- tout ce qui est relié au logiciel, aux services ou au contenu (y compris le code) figurant sur des sites Internet tiers ou dans des programmes tiers ; et
- les réclamations au titre de violation de contrat ou de garantie, ou au titre de responsabilité stricte, de négligence ou d’une autre faute dans la limite autorisée par la loi en vigueur.

Elle s’applique également, même si Microsoft connaissait ou devrait connaître l’éventualité d’un tel dommage. Si votre pays n’autorise pas l’exclusion ou la limitation de responsabilité pour les dommages indirects, accessoires ou de quelque nature que ce soit, il se peut que la limitation ou l’exclusion ci-dessus ne s’appliquera pas à votre égard.

**EFFET JURIDIQUE.** Le présent contrat décrit certains droits juridiques. Vous pourriez avoir d’autres droits prévus par les lois de votre pays. Le présent contrat ne modifie pas les droits que vous confèrent les lois de votre pays si celles-ci ne le permettent pas.

\*\*\*\*\*\*\*\*\*\*\*\*\*\*\*

